Unit DE21R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE21RU_p, DE21RP_p, UTDE12_p;

procedure DE21R(F :Proc_F_DE; M :Integer; ISTIFJ :Integer;
                IORDER :Integer; var JSTART :Integer; HMIN :Real;
                HMAX :Real; EPS :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var YPM :Array of Real; var DELTY :Array of Real;
                var RAB :Array of Real; var YP :Array of Real;
                var IERR :Integer);

implementation

procedure DE21R(F :Proc_F_DE; M :Integer; ISTIFJ :Integer;
                IORDER :Integer; var JSTART :Integer; HMIN :Real;
                HMAX :Real; EPS :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var YPM :Array of Real; var DELTY :Array of Real;
                var RAB :Array of Real; var YP :Array of Real;
                var IERR :Integer);
var
JER,N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,N11,N12,N13,IND1,IND2,IND9,IND10,
   IRET,KFLAG,MXDER,K,IRET1,IDOUB,MTYP,IWEVAL,KER,NT,NEWI,I,
   J,J1,J2,L,IR,_i :Integer;
D,E,R,R1,BND,EUP,EDWN,ENQ1,D1,D2,ENQ2,ENQ3,RACUM,XK,
   PEPSH,PR1,PR2,PR3,HOLD1 :Real;
C :Array [0..7] of Real;
COEF :Array [0..41] of Real;
P :Array [0..41] of Real;
const
ZERO :Real = 0.0;
HALF :Real = 0.5;
ONE :Real = 1.0;
ONEP :Real = 0.0001;
NDIG :Integer = 0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59,_60,_61,_62,_63,_64,_65,_66,_67,_68,_69,_70,
_71,_72,_73,_74,_75,_76,_77,_78,_79,_80,_81,_82,_83,_84,_85;
begin
{   DATA  FORTRAN  }
C[1] := -1.0;
P[0] := 2.0;
P[1] := 4.5;
P[2] := 7.333;
P[3] := 10.42;
P[4] := 13.7;
P[5] := 17.15;
P[6] := 1.0;
P[7] := 2.0;
P[8] := 12.0;
P[9] := 24.0;
P[10] := 37.89;
P[11] := 53.33;
P[12] := 70.08;
P[13] := 87.97;
P[14] := 3.0;
P[15] := 6.0;
P[16] := 9.167;
P[17] := 12.5;
P[18] := 15.98;
P[19] := 1.0;
P[20] := 1.0;
P[21] := 12.0;
P[22] := 24.0;
P[23] := 37.89;
P[24] := 53.33;
P[25] := 70.08;
P[26] := 87.97;
P[27] := 1.0;
P[28] := 1.0;
P[29] := 1.0;
P[30] := 0.5;
P[31] := 0.1667;
P[32] := 0.04133;
P[33] := 0.008267;
P[34] := 1.0;
P[35] := 1.0;
P[36] := 1.0;
P[37] := 2.0;
P[38] := 1.0;
P[39] := 0.3157;
P[40] := 0.07407;
P[41] := 0.0139;
{ EQUIVALENCE(P(1),COEF(1)) }
for _i:=0 to 41 do
 COEF[_i] := P[_i]; 

IERR := 0;
JER := 0;
HOLD1 := H;
RACUM := ONE;
N4 := M*M;
if ( ISTIFJ = 0 ) 
 then N4 := 0;
N1 := M*10+N4;
N2 := N1+1;
N3 := M;
N5 := N1+M;
N6 := N5+1;
N7 := N6+M+M;
N8 := N7+M;
N9 := N8+M;
N10 := N8-1;
IND1 := N4+1;
IND2 := N4+2;
IND9 := N4+9;
IND10 := N4+10;
IRET := 1;
KFLAG := 1;
MXDER := IORDER;
for I:=1 to M do
 begin
  if ( YPM[I-1] = 0.0 ) 
   then goto _9;
_1:
 end;
if ( ISTIFJ = 0 ) 
 then goto _2;
if ( IORDER <= 6 ) 
 then goto _3;
JER := 1;
MXDER := 6;
goto _3;
_2:
if ( IORDER <= 7 ) 
 then goto _3;
JER := 1;
MXDER := 7;
_3:
if ( JSTART <= 0 ) 
 then goto _8;
_4:
for I:=1 to M do
 begin
  for J:=1 to K do
   begin
    IR := N4+J;
    RAB[(IR-1)+(I-1)*10] := YP[(J-1)+(I-1)*8];
_5:
   end;
 end;
_COM21R.elm1 := _COM21R.elm2;
if ( H = _COM21R.elm1 ) 
 then goto _7;
_6:
RACUM := H/_COM21R.elm1;
IRET1 := 1;
goto _79;
_7:
_COM21R.elm5 := _COM21R.elm4;
_COM21R.elm3 := X;
if ( Abs(H) >= Abs(HMIN) ) and ( (Abs(H) <= Abs(HMAX)) ) 
 then H := HOLD1;
RACUM := Sign(ONE,RACUM);
if ( JSTART > 0 ) 
 then goto _30;
goto _14;
_8:
if ( JSTART+1 = 0 ) 
 then goto _13;
if ( EPS <> 0.0 ) 
 then goto _10;
KFLAG := -6;
goto _84;
_9:
KFLAG := -7;
goto _84;
_10:
for I:=1 to M do
 begin
  YP[0+(I-1)*8] := YX[I-1];
_11:
 end;
_COM21R.elm4 := 1;
F(X,YX,RAB[(N2-1)+0],M);
for I:=1 to M do
 begin
  N11 := N1+I;
  YP[1+(I-1)*8] := RAB[(N11-1)+0]*H;
_12:
 end;
_COM21R.elm2 := H;
K := 2;
goto _4;
_13:
if ( _COM21R.elm4 = _COM21R.elm5 ) 
 then JSTART := 1;
X := _COM21R.elm3;
_COM21R.elm4 := _COM21R.elm5;
K := _COM21R.elm4+1;
goto _6;
_14:
if ( ISTIFJ = 0 ) 
 then goto _15;
case _COM21R.elm4 of
 1: goto _23;
 2: goto _24;
 3: goto _25;
 4: goto _26;
 5: goto _27;
 6: goto _28;
end;
_15:
case _COM21R.elm4 of
 1: goto _16;
 2: goto _17;
 3: goto _18;
 4: goto _19;
 5: goto _20;
 6: goto _21;
 7: goto _22;
end;
_16:
C[0] := -ONE;
goto _29;
_17:
C[0] := -HALF;
C[2] := -HALF;
goto _29;
_18:
C[0] := -0.4166667;
C[2] := -0.75;
C[3] := -0.1666667;
goto _29;
_19:
C[0] := -0.375;
C[2] := -0.9166667;
C[3] := -0.3333333;
C[4] := -0.04166667;
goto _29;
_20:
C[0] := -0.3486111;
C[2] := -1.041667;
C[3] := -0.4861111;
C[4] := -0.1041667;
C[5] := -0.008333333;
goto _29;
_21:
C[0] := -0.3298611;
C[2] := -1.141667;
C[3] := -0.625;
C[4] := -0.1770833;
C[5] := -0.025;
C[6] := -0.001388889;
goto _29;
_22:
C[0] := -0.3155919;
C[2] := -1.225;
C[3] := -0.7518519;
C[4] := -0.2552083;
C[5] := -0.04861111;
C[6] := -0.4861111E-2;
C[7] := -0.1984127E-3;
goto _29;
_23:
C[0] := -ONE;
goto _29;
_24:
C[0] := -0.6666667;
C[2] := -0.3333333;
goto _29;
_25:
C[0] := -0.5454545;
C[2] := C[0];
C[3] := -0.09090909;
goto _29;
_26:
C[0] := -0.48;
C[2] := -0.7;
C[3] := -0.2;
C[4] := -0.02;
goto _29;
_27:
C[0] := -0.4379562;
C[2] := -0.8211679;
C[3] := -0.3102190;
C[4] := -0.05474453;
C[5] := -0.003649635;
goto _29;
_28:
C[0] := -0.4081633;
C[2] := -0.9206349;
C[3] := -0.4166667;
C[4] := -0.09920635;
C[5] := -0.01190476;
C[6] := -0.0005668934;
_29:
K := _COM21R.elm4+1;
IDOUB := K;
MTYP := (4-ISTIFJ) div 2;
ENQ1 := HALF/(_COM21R.elm4);
ENQ2 := HALF/(_COM21R.elm4+1);
ENQ3 := HALF/(_COM21R.elm4+2);
PEPSH := EPS;
EUP := COEF[(_COM21R.elm4-1)+(MTYP-1)*21]*PEPSH;
E := COEF[(_COM21R.elm4-1)+(MTYP-1)*7]*PEPSH;
EDWN := COEF[(_COM21R.elm4-1)+(MTYP-1)*35]*PEPSH;
BND := EPS*ENQ3/M;
IWEVAL := ISTIFJ;
case IRET of
 1: goto _30;
 2: goto _72;
end;
_30:
X := X+H;
for J:=2 to K do
 begin
  for J1:=J to K do
   begin
    J2 := K-J1+J-1;
    for I:=1 to M do
     begin
      YP[(J2-1)+(I-1)*8] := YP[(J2-1)+(I-1)*8]+YP[(J2+0)+(I-1)*8];
_31:
     end;
   end;
 end;
for I:=1 to M do
 begin
  DELTY[I-1] := ZERO;
  YX[I-1] := YP[0+(I-1)*8];
_32:
 end;
for L:=1 to 3 do
 begin
  F(X,YX,RAB[(N2-1)+0],M);
  if ( IWEVAL < 1 ) 
   then goto _38;
  for I:=1 to M do
   begin
    RAB[(IND9-1)+(I-1)*10] := YP[0+(I-1)*8];
_33:
   end;
  for J:=1 to M do
   begin
    R := EPS*EMax1(EPS,Abs(RAB[(IND9-1)+(J-1)*10]));
    if ( R <> 0.0 ) 
     then goto _34;
    X := _COM21R.elm3;
    KFLAG := -5;
    goto _50;
_34:
    YX[J-1] := YX[J-1]+R;
    D := C[0]*H/R;
    F(X,YX,RAB[(N6-1)+0],M);
    for I:=1 to M do
     begin
      N11 := I+(J-1)*N3;
      N12 := N5+I;
      N13 := N1+I;
      RAB[(N11-1)+0] := (RAB[(N12-1)+0]-RAB[(N13-1)+0])*D;
_35:
     end;
    YX[J-1] := RAB[(IND9-1)+(J-1)*10];
_36:
   end;
  N11 := N3+1;
  N12 := M*N11-N3;
  I := 1;
  while ( I<=N12 ) do
   begin
    RAB[(I-1)+0] := RAB[(I-1)+0]+ONE;
_37:
    inc(I,N11);
   end;
  IWEVAL := -1;
  if ( M = 1 ) 
   then goto _38;
  DE21RU(RAB,RAB,M,N3,NDIG,D1,D2,RAB[(N7-1)+0],RAB[(N8-1)+(
       1-1)*10],RAB[(N9-1)+0],KER);
  if ( KER ) < 0
   then goto _38
   else if ( KER ) > 0
         then goto _48
         else goto _38;
_38:
  if ( ISTIFJ <> 0 ) 
   then goto _40;
  for I:=1 to M do
   begin
    N11 := N1+I;
    RAB[(IND9-1)+(I-1)*10] := YP[1+(I-1)*8]-RAB[(N11-1)+0]*H;
_39:
   end;
  goto _45;
_40:
  for I:=1 to M do
   begin
    N11 := N5+I;
    N12 := N1+I;
    RAB[(N11-1)+0] := YP[1+(I-1)*8]-RAB[(N12-1)+0]*H;
_41:
   end;
  if ( M > 1 ) 
   then goto _42;
  RAB[(N8-1)+0] := RAB[(N6-1)+0]/RAB[0];
  goto _43;
_42:
  DE21RP(RAB,RAB[(N6-1)+0],RAB[(N7-1)+0],M,N3,RAB[(N8-1)+0]);
_43:
  for I:=1 to M do
   begin
    IR := N10+I;
    RAB[(IND9-1)+(I-1)*10] := RAB[(IR-1)+0];
_44:
   end;
_45:
  NT := M;
  for I:=1 to M do
   begin
    YP[0+(I-1)*8] := YP[0+(I-1)*8]+C[0]*RAB[(IND9-1)+(I-1)*10];
    YP[1+(I-1)*8] := YP[1+(I-1)*8]-RAB[(IND9-1)+(I-1)*10];
    YX[I-1] := YP[0+(I-1)*8];
    DELTY[I-1] := DELTY[I-1]+RAB[(IND9-1)+(I-1)*10];
    if ( Abs(RAB[(IND9-1)+(I-1)*10]) <= (BND*YPM[I-1]) ) 
     then NT := NT-1;
_46:
   end;
  if ( NT <= 0 ) 
   then goto _53;
_47:
 end;
_48:
X := X-H;
IR := -1;
if ( (Abs(H) <= (Abs(HMIN)*ONEP)) ) and ( ((IWEVAL-MTYP)
 < IR) ) 
 then goto _49;
if ( (ISTIFJ = 0) ) or ( (IWEVAL <> 0) ) 
 then RACUM := RACUM*0.25;
IWEVAL := ISTIFJ;
IRET1 := 2;
goto _79;
_49:
KFLAG := -3;
_50:
for I:=1 to M do
 begin
  for J:=1 to K do
   begin
    IR := N4+J;
    YP[(J-1)+(I-1)*8] := RAB[(IR-1)+(I-1)*10];
_51:
   end;
 end;
for I:=1 to M do
 begin
  YX[I-1] := YP[0+(I-1)*8];
_52:
 end;
H := _COM21R.elm1;
_COM21R.elm4 := _COM21R.elm5;
JSTART := _COM21R.elm4;
goto _83;
_53:
D := ZERO;
for I:=1 to M do
 begin
  D := D+IntPower((DELTY[I-1]/YPM[I-1])/E,2);
_54:
 end;
IWEVAL := 0;
if ( D > 1.0 ) 
 then goto _58;
if ( Abs(H) < Abs(HOLD1) ) 
 then BUL := False;
if ( K < 3 ) 
 then goto _56;
for J:=3 to K do
 begin
  for I:=1 to M do
   begin
    YP[(J-1)+(I-1)*8] := YP[(J-1)+(I-1)*8]+C[J-1]*DELTY[I-1];
_55:
   end;
 end;
_56:
KFLAG := 1;
_COM21R.elm2 := H;
if ( IDOUB <= 1 ) 
 then goto _59;
IDOUB := IDOUB-1;
if ( IDOUB > 1 ) 
 then goto _74;
for I:=1 to M do
 begin
  RAB[(IND10-1)+(I-1)*10] := DELTY[I-1];
_57:
 end;
goto _74;
_58:
KFLAG := KFLAG-2;
if ( Abs(H) <= (Abs(HMIN)*ONEP) ) 
 then goto _78;
X := _COM21R.elm3;
IR := -9;
if ( KFLAG <= IR ) 
 then goto _76;
_59:
PR2 := Power(D,ENQ2)*1.5;
PR3 := 1.E+18;
IR := -1;
if ( (_COM21R.elm4 >= MXDER) ) or ( (KFLAG <= IR) ) 
 then goto _61;
D := ZERO;
for I:=1 to M do
 begin
  D := D+IntPower(((DELTY[I-1]-RAB[(IND10-1)+(I-1)*10])/YPM[I-1])/EUP,2);
_60:
 end;
PR3 := Power(D,ENQ3)*1.75;
_61:
PR1 := 1.E+18;
if ( _COM21R.elm4 <= 1 ) 
 then goto _63;
IR := _COM21R.elm4-1;
if ( COEF[(IR-1)+(MTYP-1)*35]*EPS = 0.0 ) 
 then goto _63;
D := ZERO;
for I:=1 to M do
 begin
  D := D+IntPower((YP[(K-1)+(I-1)*8]/YPM[I-1])/EDWN,2);
_62:
 end;
PR1 := Power(D,ENQ3)*1.6;
_63:
if ( PR2 <= PR3 ) 
 then goto _69;
if ( PR3 < PR1 ) 
 then goto _70;
_64:
R := 1.0/EMax1(PR1,1.E-3);
NEWI := _COM21R.elm4-1;
_65:
IDOUB := 10;
if ( (KFLAG = 1) ) and ( (R < (1.1)) ) 
 then goto _74;
if ( NEWI <= _COM21R.elm4 ) 
 then goto _67;
XK := ONE/K;
for I:=1 to M do
 begin
  YP[(NEWI+0)+(I-1)*8] := DELTY[I-1]*C[K-1]*XK;
_66:
 end;
_67:
K := NEWI+1;
if ( KFLAG = 1 ) 
 then goto _71;
RACUM := RACUM*R;
IRET1 := 3;
goto _79;
_68:
if ( NEWI = _COM21R.elm4 ) 
 then goto _30;
_COM21R.elm4 := NEWI;
goto _14;
_69:
if ( PR2 > PR1 ) 
 then goto _64;
NEWI := _COM21R.elm4;
R := 1.0/EMax1(PR2,1.E-3);
goto _65;
_70:
R := 1.0/EMax1(PR3,1.E-3);
NEWI := _COM21R.elm4+1;
goto _65;
_71:
IRET := 2;
R := EMin1(R,Abs(HMAX/H));
H := H*R;
_COM21R.elm2 := H;
if ( _COM21R.elm4 = NEWI ) 
 then goto _72;
_COM21R.elm4 := NEWI;
goto _14;
_72:
R1 := ONE;
for J:=2 to K do
 begin
  R1 := R1*R;
  for I:=1 to M do
   begin
    YP[(J-1)+(I-1)*8] := YP[(J-1)+(I-1)*8]*R1;
_73:
   end;
 end;
IDOUB := K;
_74:
for I:=1 to M do
 begin
  YPM[I-1] := EMax1(YPM[I-1],Abs(YP[0+(I-1)*8]));
_75:
 end;
JSTART := _COM21R.elm4;
goto _83;
_76:
if ( _COM21R.elm4 = 1 ) 
 then goto _82;
F(X,YX,RAB[(N2-1)+0],M);
R := H/_COM21R.elm1;
for I:=1 to M do
 begin
  YP[0+(I-1)*8] := RAB[(IND1-1)+(I-1)*10];
  YX[I-1] := YP[0+(I-1)*8];
  N11 := N1+I;
  RAB[(IND2-1)+(I-1)*10] := _COM21R.elm1*RAB[(N11-1)+0];
  YP[1+(I-1)*8] := RAB[(IND2-1)+(I-1)*10]*R;
_77:
 end;
_COM21R.elm4 := 1;
KFLAG := 1;
goto _14;
_78:
KFLAG := -1;
_COM21R.elm2 := H;
JSTART := _COM21R.elm4;
goto _84;
_79:
RACUM := Sign(EMax1(Abs(HMIN/_COM21R.elm1),Abs(RACUM)),RACUM);
RACUM := Sign(EMin1(Abs(RACUM),Abs(HMAX/_COM21R.elm1)),RACUM);
R1 := ONE;
for J:=2 to K do
 begin
  R1 := R1*RACUM;
  for I:=1 to M do
   begin
    IR := N4+J;
    YP[(J-1)+(I-1)*8] := RAB[(IR-1)+(I-1)*10]*R1;
_80:
   end;
 end;
H := _COM21R.elm1*RACUM;
for I:=1 to M do
 begin
  YP[0+(I-1)*8] := RAB[(IND1-1)+(I-1)*10];
  YX[I-1] := YP[0+(I-1)*8];
_81:
 end;
IDOUB := K;
case IRET1 of
 1: goto _7;
 2: goto _30;
 3: goto _68;
end;
_82:
KFLAG := -4;
goto _50;
_83:
if ( KFLAG = 1 ) 
 then goto _85;
_84:
IERR := 64-KFLAG;
_85:
if ( JER <> 0 ) 
 then UTDE12(JER,21);
if ( IERR > 65 ) 
 then IERR := IERR-1;
if ( IERR <> 0 ) 
 then UTDE12(IERR,21);
if ( (IERR = 0) ) and ( (JER <> 0) ) 
 then IERR := JER;
end;

end.
